


#include "spe_logger.h"

#include <stdio.h>
#include <stdlib.h>
//#include "or.h"
#include "netinet/tcp.h"
#include <sys/ioctl.h>
#include <linux/sockios.h>
#include <poll.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>

#include <netinet/ip.h>
#include <netinet/tcp.h>
#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif
#ifdef HAVE_SYS_FCNTL_H
#include <sys/fcntl.h>
#endif
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif
#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif
#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif
#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif
#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif
#ifdef HAVE_ASSERT_H
#include <assert.h>
#endif
#ifdef HAVE_TIME_H
#include <time.h>
#endif
typedef unsigned int uint32_t;
typedef unsigned char uint8_t;
typedef unsigned short uint16_t;



#define BASE_CONNECTION_MAGIC 0x7C3C304Eu
#define OR_CONNECTION_MAGIC 0x7D31FF03u
#define EDGE_CONNECTION_MAGIC 0xF0374013u
#define DIR_CONNECTION_MAGIC 0x9988ffeeu
#define CONTROL_CONNECTION_MAGIC 0x8abc765du


//#define SAFEPRINT if(f)

typedef struct {
  unsigned int magic; /**< Magic cookie for debugging: Must be set to
                   *   BUFFER_MAGIC. */
  char *mem;      /**< Storage for data in the buffer. */
  char *cur;      /**< The first byte used for storing data in the buffer. */
  size_t highwater; /**< Largest observed datalen since last buf_shrink. */
  size_t len;     /**< Maximum amount of data that <b>mem</b> can hold. */
  size_t memsize; /**< How many bytes did we actually allocate? Can be less
                   * than 'len' if we shortened 'len' by a few bytes to make
                   * zlib wrap around more easily. */
  size_t datalen; /**< Number of bytes currently in <b>mem</b>. */
} buf_t ;

typedef struct connection_t {
  uint32_t magic; /**< For memory debugging: must equal one of
                   * *_CONNECTION_MAGIC. */

  uint8_t type; /**< What kind of connection is this? */
  uint8_t state; /**< Current state of this connection. */
  uint8_t purpose; /**< Only used for DIR and EXIT types currently. */

  /* The next fields are all one-bit booleans. Some are only applicable
   * to connection subtypes, but we hold them here anyway, to save space.
   * (Currently, they all fit into a single byte.) */
  unsigned wants_to_read:1; /**< Boolean: should we start reading again once
                            * the bandwidth throttler allows it? */
  unsigned wants_to_write:1; /**< Boolean: should we start writing again once
                             * the bandwidth throttler allows reads? */
  unsigned hold_open_until_flushed:1; /**< Despite this connection's being
                                      * marked for close, do we flush it
                                      * before closing it? */
  unsigned int inbuf_reached_eof:1; /**< Boolean: did read() return 0 on this
                                     * conn? */
  unsigned edge_has_sent_end:1; /**< For debugging; only used on edge
                         * connections.  Set once we've set the stream end,
                         * and check in connection_about_to_close_connection().
                         */
  /** Used for OR conns that shouldn't get any new circs attached to them. */
  unsigned int or_is_obsolete:1;
  /** For AP connections only. If 1, and we fail to reach the chosen exit,
   * stop requiring it. */
  unsigned int chosen_exit_optional:1;

  int s; /**< Our socket; -1 if this connection is closed. */
  int conn_array_index; /**< Index into the global connection array. */
  /*struct event*/ void * read_event; /**< Libevent event structure. */
  /*struct event*/ void * write_event; /**< Libevent event structure. */
  buf_t *inbuf; /**< Buffer holding data read over this connection. */
  buf_t *outbuf; /**< Buffer holding data to write over this connection. */
  size_t outbuf_flushlen; /**< How much data should we try to flush from the
                           * outbuf? */
  time_t timestamp_lastread; /**< When was the last time libevent said we could
                              * read? */
  time_t timestamp_lastwritten; /**< When was the last time libevent said we
                                 * could write? */
  time_t timestamp_created; /**< When was this connection_t created? */

  uint32_t addr; /**< IP of the other side of the connection; used to identify
                  * routers, along with port. */
  uint16_t port; /**< If non-zero, port  on the other end
                  * of the connection. */
  uint16_t marked_for_close; /**< Should we close this conn on the next
                              * iteration of the main loop? (If true, holds
                              * the line number where this connection was
                              * marked.) */
  const char *marked_for_close_file; /**< For debugging: in which file were
                                      * we marked for close? */
  char *address; /**< FQDN (or IP) of the guy on the other end.
                  * strdup into this, because free_connection frees it. */

} connection_t;

void tor_socket(int obs, void * p, void** state, spe_logger_t* f) {
			
	if (obs < 0 ) {
		//init
	}
	if (obs == 0) {
		//make obs

	}
	if (obs > 0) { 
		//free

	}
		
}
void outbuffer(int obs, void * p, void** state, spe_logger_t* logger) {

/* uint32_t magic; /**< Magic cookie for debugging: Must be set to
                   *   BUFFER_MAGIC. * /
  char *mem;      /**< Storage for data in the buffer. * /
  char *cur;      /**< The first byte used for storing data in the buffer. * /
  size_t highwater; /**< Largest observed datalen since last buf_shrink. * /
  size_t len;     /**< Maximum amount of data that <b>mem</b> can hold. * /
  size_t memsize; /**< How many bytes did we actually allocate? Can be less
                   * than 'len' if we shortened 'len' by a few bytes to make
                   * zlib wrap around more easily. * /
  size_t datalen; /**< Number of bytes currently in <b>mem</b>. * /
*/
	if (!p) return;
	if (obs < 0 ) {
		//init
//		*state = buf->cur; 
		
	}
	if (obs == 0) {
	
		//make obs
		struct timeval tv;
		int delta = 0;//(int) (buf->cur - (char*)*state);
	
		if (*(int*)p != 0xB0FFF312u) return;
		buf_t* buf = (buf_t*) p;
	
		gettimeofday(&tv, NULL);
//		if (delta < 0) delta += buf->memsize;
//		*state = buf->cur;
		if (buf->datalen) {
			char *last = buf->cur + buf->datalen - 512;
  			char *end = buf->mem + buf->len;
			last = (last < end) ? last : (last - buf->len);
			
			uint16_t circ_id = ntohs(*(uint16_t*)(last));
			spe_logger_log(logger, "%p %d %d %d %d %d %d %d\n", buf, tv.tv_sec, tv.tv_usec, buf->datalen, delta, buf->highwater, buf->len, circ_id);
		}
		else { 
			spe_logger_log(logger, "%p %d %d %d %d %d %d %d\n", buf, tv.tv_sec, tv.tv_usec, buf->datalen, delta, buf->highwater, buf->len, 0);
		}
	}
	if (obs > 0) { 
		//free

	}
		
}

void inbuffer(int obs, void * p, void** state, spe_logger_t* logger) {
	outbuffer(obs, p, state, logger);
	if (obs < 0 ) {
		//init
	}
	if (obs == 0) {
		//make obs

	}
	if (obs > 0) { 
		//free

	}
		
}

void connection(int obs, void * p, void** state, spe_logger_t* logger) {
	if (!p) return;
	
	if (obs < 0 ) {
		//init
	}
	if (obs == 0) {
		if (*(int*)p != OR_CONNECTION_MAGIC) return; 
		
		connection_t* conn = (connection_t*) p;
		struct timeval tv;
		int sock_inbufsize=-1,sock_outbufsize=-1;
		struct pollfd fd;
		int retpoll;
		int port;
		int intbuf, lenbuf, intrbuf, lenrbuf;
		struct tcp_info ti;
		int state, ca_state; 
		struct sockaddr sockname;
		socklen_t sockname_len;
		if (conn->marked_for_close || conn->s < 0) return;	
/*		fd_set fds;
		FD_ZERO( &fds);
		FD_SET ( conn->s, &fds );
	
		tv.tv_sec = 0;
		tv.tv_usec = 0;
		ret = select(conn->s+1, 0, &fds,0,&tv);*/
		gettimeofday(&tv,NULL);
		ioctl(conn->s , SIOCINQ, &sock_inbufsize);
		ioctl(conn->s , SIOCOUTQ, &sock_outbufsize);
		
		fd.fd = conn->s;
		fd.events = POLLOUT;
		retpoll = poll(&fd, 1, 0);
		lenbuf = sizeof(intbuf);
		lenrbuf = sizeof(intrbuf);
		sockname_len = sizeof(sockname);
		getsockopt(conn->s,  SOL_SOCKET, SO_SNDBUF, &intbuf, &lenbuf);
		getsockopt(conn->s,  SOL_SOCKET, SO_RCVBUF, &intrbuf, &lenrbuf);
		lenbuf = sizeof(ti);
		getsockopt(conn->s,  IPPROTO_TCP, TCP_INFO, &ti, &lenbuf);
		getpeername(conn->s, &sockname, &sockname_len);
		port = ntohs(((struct sockaddr_in*)&sockname)->sin_port);
		
		
		state = (int)ti.tcpi_state;
		ca_state = (int)ti.tcpi_ca_state;
		
		spe_logger_log(logger, "%p %d %d %d %p %d %d %d %d %d %d %d %d %d %d %d %d %s.%d\n", conn,
		                      tv.tv_sec, 
		                         tv.tv_usec, 
		                            retpoll, 
		                               conn->outbuf, 
		                                  sock_inbufsize, 
		                                      sock_outbufsize, 
		                                         intbuf,
							    intrbuf, 
  		                                               ti.tcpi_snd_mss, 
  		                                                  ti.tcpi_unacked, 
		                                                     ti.tcpi_sacked,
		                                                        ti.tcpi_retrans, 
		                                                           ti.tcpi_lost, 
		                                                              ti.tcpi_rtt,
		                                                                 state,
		                                                                    ca_state,
			inet_ntoa(((struct sockaddr_in*)&sockname)->sin_addr),
											  port);
			
		//make obs

	}
	if (obs > 0) { 
		//free

	}
		
}


